import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
} from '@loafer/core/decorator';

import Annotation from '@loafer/core/annotation/Annotation';

export interface PouchConfig {
  qualifier?: PropertyType;
  type?: ClassType;
}

export class PouchAnnotation extends Annotation {
  private readonly Qualifier: PropertyType;
  private readonly Type: ClassType;
  public constructor(config: PouchConfig = {}) {
    super();
    this.Qualifier = config.qualifier;
    this.Type = config.type;
  }

  public onMethodDecorator = <T>(target: Object, propertyKey: PropertyType,
                                 descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void => {
    console.log('Pouch');
  }
}

export const Pouch = Decorator.create(PouchAnnotation);

export default Pouch;
