import {
  ClassType,
} from '@loafer/core/constants/types';

export abstract class AnnotatedElement {
  private _annotationMap: Map<ClassType, any>;

  protected constructor() {
    this._annotationMap = new Map();
  }

  public getDeclaredAnnotation(type: ClassType): any {
    return this._annotationMap.get(type);
  }
  public getDeclaredAnnotations(): IterableIterator<any> {
    return this._annotationMap.values();
  }

  public addAnnotation(annotation: any): void {
    const type: ClassType = Object.getPrototypeOf(annotation);
    this._annotationMap.set(type, annotation);
  }

  public hasAnnotation(type: ClassType): boolean {
    return this._annotationMap.has(type);
  }

  // public abstract getAnnotation(type: ClassType): any;
  // public abstract getAnnotations(): IterableIterator<any>;

}

export default AnnotatedElement;
