import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import AnnotatedElement from './AnnotatedElement';
import Constructor from './Constructor';


export class Property extends AnnotatedElement {
  private _type: ClassType;
  private _name: PropertyType;

  public constructor(type: ClassType, name: PropertyType) {
    super();
    this._type = type;
    this._name = name;
  }

  public get Name(): PropertyType {
    return this._name;
  }

  public get Type(): ClassType {
    return this._type;
  }
}

export default Property;
