import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
 } from '@loafer/core/decorator';

import Annotation from '@loafer/core/annotation/Annotation';

export interface InjectConfig {
  qualifier?: PropertyType;
  required?: boolean;
  type?: ClassType;
}

export class InjectAnnotation extends Annotation {
  private readonly Qualifier: PropertyType;
  private readonly Required: boolean;
  private readonly Type: ClassType;

  public constructor(config: InjectConfig = {}) {
    super();
    this.Qualifier = config.qualifier;
    this.Required = config.required;
    this.Type = config.type;
  }

  public onPropertyDecorator = (target: Object, propertyKey: PropertyType): void => {
    console.log('Inject');
  }
  public onMethodDecorator = <T>(target: Object, propertyKey: PropertyType,
                                 descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void => {
    console.log('Inject');
  }
  public onParameterDecorator = (target: Object, propertyKey: PropertyType, parameterIndex: number): void => {
    console.log('Inject');
  }

}

export const Inject = Decorator.create(InjectAnnotation);

export default Inject;
