import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import AliasRegistry from '@loafer/core/AliasRegistry';

import {
  FactoryPouch,
} from '@loafer/pouches/factory';

import {
  PouchDefinition,
} from '@loafer/pouches/factory/config';

import {
  DefaultSingletonPouchRegistry,
} from '@loafer/pouches/factory/support';

export interface PouchNameGenerator {
	/**
	 * Generate a pouch name for the given pouch definition.
	 * @param definition the pouch definition to generate a name for
	 * @param registry the pouch definition registry that the given definition
	 * is supposed to be registered with
	 * @return the generated pouch name
	 */
	generatePouchName(definition: PouchDefinition, registry: PouchDefinitionRegistry): PropertyType;
}

export default PouchNameGenerator;
