import Inject from '@loafer/pouches/decorator/Inject';
import WebSocketRPC from '../websocket/WebSocketRPC';

abstract class Service {
  @Inject({required: true})
  private webSocketRPC: WebSocketRPC;
  private name: string;
  protected constructor(name: string) {
    this.name = name;

  }

  protected send<T>(methodName: string, args: any): Promise<T> {
    return this.webSocketRPC.Call(`${this.name}.${methodName}`, args)
      .then(result => {
        return result;
      })
      .catch(e => {
        throw e;
      });
  }
}

export default Service;
